import type { Submission } from "src/tools/interfaces";
import * as fs from "fs";
import * as path from "path";
import { decode } from "../../tools/judge";
import { subjects } from "../../tools/interfaces";
import process from 'process';


export function saveFile(username: string, files: Submission[]) {
  const mainFolder = getFolder(files[0], username);
  files.forEach((file) => {
    let utc = (new Date()).getTime();
    let pathName = path.join(mainFolder, utc + "_" + file.filename);

    fs.writeFile(
      pathName,
      decode(file.code),
      function (err) {
        if (err) return console.log(err);
        console.log("its ok!");
      }
    );
  });
}

function getActualYearPath(): string {
  const todaysDate = new Date();
  const year = todaysDate.getFullYear().toString();
  const actualYearPath = path.join(process.env["VITE_STUDENTS_DATA_FOLDER"], year);

  if (!fs.existsSync(actualYearPath)) {
    fs.mkdirSync(actualYearPath, { recursive: true });
  }
  return actualYearPath;
}

function getFolder(submission: Submission, username: string): string {
  const subjectFolder = path.join(
    getActualYearPath(),
    subjects.find((element) => element.id === submission.subject).code
  );

  if (!fs.existsSync(subjectFolder)) {
    fs.mkdirSync(subjectFolder, { recursive: true });
  }
  const submissionFolder = path.join(subjectFolder, submission.num.toString());
  if (!fs.existsSync(submissionFolder)) {
    fs.mkdirSync(submissionFolder, { recursive: true });
  }

  const userFolder = path.join(submissionFolder, username);
  if (!fs.existsSync(userFolder)) {
    fs.mkdirSync(userFolder, { recursive: true });
  }
  return userFolder;
}
