import { tryToAuth } from "../../tools/ldap";
import * as fs from "fs";
import process from 'process';

export async function post(req) {
  var data = JSON.parse(req.body);
  console.log();

  let username = data.username;
  let password = data.password;

  let some = await tryToAuth(username, password);

  if (some.body.auth) {
    return {
      body: {
        auth: some.body.auth,
        login: readUsers(username),
      },
    };
  } else {
    return {
      body: {
        auth: some.body.auth,
        login: some.body.message,
      },
    };
  }
}

function readUsers(username: string): string {
  try {
    const data = fs.readFileSync(process.env["VITE_GLOBAL_DATA_FOLDER"] + "/users", "utf8");
    const user = data.split("\n").filter((row) => row.includes(username));
    return user.toString();
  } catch (err) {
    console.error(err);
    return "user not found on server";
  }
}
